Index: orxonox/trunk/src/Makefile.am
===================================================================
--- orxonox/trunk/src/Makefile.am	(revision 3235)
+++ orxonox/trunk/src/Makefile.am	(revision 3236)
@@ -10,9 +10,9 @@
 		 world.cc \
 		 player.cc \
+		 collision.cc \
 		 data_tank.cc \
 		 world_entity.cc \
 		 vector.cc \
 		 camera.cc \
-		 collision.cc \
 		 command_node.cc \
 		 ini_parser.cc \
@@ -31,4 +31,5 @@
 noinst_HEADERS = ability.h \
 		 data_tank.h \
+		 collision.h \
 		 npc.h \
 		 stdincl.h \
@@ -45,5 +46,4 @@
 		 power_up.h \
 		 vector.h \
-		 collision.h \
 		 keynames.h \
 		 proto_class.h \
Index: orxonox/trunk/src/Makefile.in
===================================================================
--- orxonox/trunk/src/Makefile.in	(revision 3235)
+++ orxonox/trunk/src/Makefile.in	(revision 3236)
@@ -54,6 +54,6 @@
 PROGRAMS = $(bin_PROGRAMS)
 am_orxonox_OBJECTS = orxonox.$(OBJEXT) world.$(OBJEXT) \
-	player.$(OBJEXT) data_tank.$(OBJEXT) world_entity.$(OBJEXT) \
-	vector.$(OBJEXT) camera.$(OBJEXT) collision.$(OBJEXT) \
+	player.$(OBJEXT) collision.$(OBJEXT) data_tank.$(OBJEXT) \
+	world_entity.$(OBJEXT) vector.$(OBJEXT) camera.$(OBJEXT) \
 	command_node.$(OBJEXT) ini_parser.$(OBJEXT) keynames.$(OBJEXT) \
 	track.$(OBJEXT) base_entity.$(OBJEXT) game_loader.$(OBJEXT) \
@@ -117,7 +117,4 @@
 DEFS = @DEFS@
 DEPDIR = @DEPDIR@
-DOXYGEN = @DOXYGEN@
-DOXYGEN_FALSE = @DOXYGEN_FALSE@
-DOXYGEN_TRUE = @DOXYGEN_TRUE@
 ECHO_C = @ECHO_C@
 ECHO_N = @ECHO_N@
@@ -199,9 +196,9 @@
 		 world.cc \
 		 player.cc \
+		 collision.cc \
 		 data_tank.cc \
 		 world_entity.cc \
 		 vector.cc \
 		 camera.cc \
-		 collision.cc \
 		 command_node.cc \
 		 ini_parser.cc \
@@ -220,4 +217,5 @@
 noinst_HEADERS = ability.h \
 		 data_tank.h \
+		 collision.h \
 		 npc.h \
 		 stdincl.h \
@@ -234,5 +232,4 @@
 		 power_up.h \
 		 vector.h \
-		 collision.h \
 		 keynames.h \
 		 proto_class.h \
Index: orxonox/trunk/src/camera.cc
===================================================================
--- orxonox/trunk/src/camera.cc	(revision 3235)
+++ orxonox/trunk/src/camera.cc	(revision 3236)
@@ -42,7 +42,7 @@
   this->t = 0.0;
 
-  this->actual_place.r.x = 0.0;
-  this->actual_place.r.y = 10.0;
-  this->actual_place.r.z = -5.0;
+  this->actualPlace.r.x = 0.0;
+  this->actualPlace.r.y = 10.0;
+  this->actualPlace.r.z = -5.0;
 }
 
@@ -66,5 +66,5 @@
     {this->t += deltaT;}
   //printf("time is: t=%f\n", t );
-  update_desired_place();
+  updateDesiredPlace();
   jump(NULL);
 }
@@ -89,5 +89,5 @@
 	if( bound != NULL)
 	  {
-	    bound->get_lookat (&lookat);
+	    bound->getLookat (&lookat);
 	    orx->getWorld()->calcCameraPos (&lookat, &plFocus);
 	    Quaternion *fr;
@@ -169,5 +169,5 @@
 	if(bound != null)
 	  {
-	    Placement *plBound = bound->get_placement();
+	    Placement *plBound = bound->getPlacement();
 	    Vector vDirection(0.0, 0.0, 1.0);
 	    Vector eclipticOffset(0.0, 0.0, 5.0);
@@ -237,9 +237,9 @@
   // rotation
   float matrix[4][4];
-  actual_place.w.conjugate().matrix (matrix);
+  actualPlace.w.conjugate().matrix (matrix);
   /* orientation and */
   glMultMatrixf ((float*)matrix);
   /*  translation */
-  glTranslatef (-actual_place.r.x, -actual_place.r.y,- actual_place.r.z);
+  glTranslatef (-actualPlace.r.x, -actualPlace.r.y,- actualPlace.r.z);
 //Placement *plBound = bound->get_placement();
 
Index: orxonox/trunk/src/camera.h
===================================================================
--- orxonox/trunk/src/camera.h	(revision 3235)
+++ orxonox/trunk/src/camera.h	(revision 3236)
@@ -26,5 +26,5 @@
  private:
   WorldEntity* bound;		//!< the WorldEntity the Camera is bound to
-  Placement actual_place;	        //!< the Camera's current position
+  Placement actualPlace;	        //!< the Camera's current position
   Placement desiredPlace;        //!< where the Camera should be according to calculations
   World* world;
Index: orxonox/trunk/src/command_node.cc
===================================================================
--- orxonox/trunk/src/command_node.cc	(revision 3235)
+++ orxonox/trunk/src/command_node.cc	(revision 3236)
@@ -54,5 +54,5 @@
   this->bEnabled = true;
   this->world = NULL;
-  this->load_bindings (filename);
+  this->loadBindings (filename);
 }
 
@@ -139,7 +139,7 @@
   int* index;
   
-  while( parser.next_var (namebuf, valuebuf) != -1)
-    {
-      index = name_to_index (namebuf);
+  while( parser.nextVar (namebuf, valuebuf) != -1)
+    {
+      index = nameToIndex (namebuf);
       switch( index[0])
 	{
@@ -208,5 +208,5 @@
 }
 
-void CommandNode::process_local ()
+void CommandNode::processLocal ()
 {
   SDL_Event event;
Index: orxonox/trunk/src/command_node.h
===================================================================
--- orxonox/trunk/src/command_node.h	(revision 3235)
+++ orxonox/trunk/src/command_node.h	(revision 3236)
@@ -61,5 +61,5 @@
   void reset ();
   void enable (bool bEnabled);
-  void load_bindings (char* filename);
+  void loadBindings (char* filename);
   void bind (WorldEntity* entity);
   void unbind (WorldEntity* entity);
Index: orxonox/trunk/src/environment.cc
===================================================================
--- orxonox/trunk/src/environment.cc	(revision 3235)
+++ orxonox/trunk/src/environment.cc	(revision 3236)
@@ -71,6 +71,6 @@
   float matrix[4][4];
   
-  glTranslatef(get_placement()->r.x,get_placement()->r.y,get_placement()->r.z);
-  get_placement()->w.matrix (matrix);
+  glTranslatef(getPlacement()->r.x,getPlacement()->r.y,getPlacement()->r.z);
+  getPlacement()->w.matrix (matrix);
   glMultMatrixf ((float*)matrix);
 
Index: orxonox/trunk/src/player.h
===================================================================
--- orxonox/trunk/src/player.h	(revision 3235)
+++ orxonox/trunk/src/player.h	(revision 3236)
@@ -19,5 +19,5 @@
   ~Player();
   
-  virtual void post_spawn();
+  virtual void postSpawn();
   virtual void tick(float time);
   virtual void hit(WorldEntity* weapon, Vector loc);
Index: orxonox/trunk/src/world.h
===================================================================
--- orxonox/trunk/src/world.h	(revision 3235)
+++ orxonox/trunk/src/world.h	(revision 3236)
@@ -85,63 +85,3 @@
 };
 
-/**
-    \brief spawn a new WorldEntity at a Location
-    \param loc: the Location where the Entity should be spawned
-    \param owner: a pointer to the parent of the Entity
-    \return a pointer to the new WorldEntity or NULL if there was an error
-    
-    You can use this function to spawn any derivation of WorldEntity you want, just specify the desired
-    class within the template specification brackets. Do not attempt to spawn any classes that have NOT been
-    derived from WorldEntity, you won't even be able to compile the code. Note that this version of spawn()
-    works with both free and bound WorldEntities.
-*/ 
-template<typename T> T* World::spawn(Location* loc = NULL, WorldEntity* owner = NULL)
-{
-  Location zeroloc;
-  T* entity = new T();
-  entities->add ((WorldEntity*)entity, LIST_ADD_NEXT);
-  if( loc == NULL)
-    {
-      zeroloc.dist = 0;
-      zeroloc.part = 0;
-      zeroloc.pos = Vector();
-      zeroloc.rot = Quaternion();
-      loc = &zeroloc;
-    }
-  entity->init (loc, owner);
-  if (entity->bFree)
-    {
-      track[loc->part].map_coords( loc, entity->get_placement());
-    }
-  entity->post_spawn ();
-  return entity;
-}
-
-/**
-    \brief spawn a new WorldEntity at a Placement
-    \param lplc: the placement where the Entity should be spawned
-    \param owner: a pointer to the parent of the Entity
-    \return a pointer to the new WorldEntity or NULL if there was an error
-    
-    You can use this function to spawn any FREE derivation of WorldEntity you want, just specify the desired
-    class within the template specification brackets. Do not attempt to spawn any classes that have NOT been
-    derived from WorldEntity, you won't even be able to compile the code. Note that this version of spawn()
-    works with free WorldEntities only, you will provoke an error message if you try to spawn a bound Entity with 
-    a Placement.
-*/ 
-template<typename T> T* World::spawn(Placement* plc, WorldEntity* owner = NULL)
-{
-  T* entity = new T();
-  entities->add ((WorldEntity*)entity, LIST_ADD_NEXT);
-  entity->init (plc, owner);
-  if (!entity->bFree)
-    {
-      printf("Can't spawn unfree entity with placement\n"); 
-      entities->remove( (WorldEntity*)entity, LIST_FIND_FW);
-      return NULL;
-    }
-  entity->post_spawn ();
-  return entity;
-}
-
 #endif /* _WORLD_H */