Index: orxonox/branches/updater/src/gui/Makefile.am
===================================================================
--- orxonox/branches/updater/src/gui/Makefile.am	(revision 3244)
+++ orxonox/branches/updater/src/gui/Makefile.am	(revision 3250)
@@ -11,5 +11,6 @@
 	    orxonox_gui_flags.cc \
 	    orxonox_gui_banner.cc \
-	    orxonox_gui_keys.cc
+	    orxonox_gui_keys.cc \
+	    orxonox_gui_update.cc
 
 noinst_HEADERS=orxonox_gui.h \
@@ -20,5 +21,6 @@
 	    orxonox_gui_flags.h \
 	    orxonox_gui_banner.h \
-	    orxonox_gui_keys.h
+	    orxonox_gui_keys.h \
+	    orxonox_gui_update.h
 
 #  uncomment the following if orxonox requires the mathlibrary
Index: orxonox/branches/updater/src/gui/Makefile.in
===================================================================
--- orxonox/branches/updater/src/gui/Makefile.in	(revision 3244)
+++ orxonox/branches/updater/src/gui/Makefile.in	(revision 3250)
@@ -56,5 +56,6 @@
 	orxonox_gui_video.$(OBJEXT) orxonox_gui_audio.$(OBJEXT) \
 	orxonox_gui_exec.$(OBJEXT) orxonox_gui_flags.$(OBJEXT) \
-	orxonox_gui_banner.$(OBJEXT) orxonox_gui_keys.$(OBJEXT)
+	orxonox_gui_banner.$(OBJEXT) orxonox_gui_keys.$(OBJEXT) \
+	orxonox_gui_update.$(OBJEXT)
 gui_OBJECTS = $(am_gui_OBJECTS)
 gui_LDADD = $(LDADD)
@@ -69,4 +70,5 @@
 @AMDEP_TRUE@	./$(DEPDIR)/orxonox_gui_gtk.Po \
 @AMDEP_TRUE@	./$(DEPDIR)/orxonox_gui_keys.Po \
+@AMDEP_TRUE@	./$(DEPDIR)/orxonox_gui_update.Po \
 @AMDEP_TRUE@	./$(DEPDIR)/orxonox_gui_video.Po
 CXXCOMPILE = $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) \
@@ -190,5 +192,6 @@
 	    orxonox_gui_flags.cc \
 	    orxonox_gui_banner.cc \
-	    orxonox_gui_keys.cc
+	    orxonox_gui_keys.cc \
+	    orxonox_gui_update.cc
 
 noinst_HEADERS = orxonox_gui.h \
@@ -199,5 +202,6 @@
 	    orxonox_gui_flags.h \
 	    orxonox_gui_banner.h \
-	    orxonox_gui_keys.h
+	    orxonox_gui_keys.h \
+	    orxonox_gui_update.h
 
 
@@ -224,7 +228,7 @@
 	  esac; \
 	done; \
-	echo ' cd $(top_srcdir) && $(AUTOMAKE) --foreign  src/gui/Makefile'; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  src/gui/Makefile'; \
 	cd $(top_srcdir) && \
-	  $(AUTOMAKE) --foreign  src/gui/Makefile
+	  $(AUTOMAKE) --gnu  src/gui/Makefile
 .PRECIOUS: Makefile
 Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
@@ -284,4 +288,5 @@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox_gui_gtk.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox_gui_keys.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox_gui_update.Po@am__quote@
 @AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/orxonox_gui_video.Po@am__quote@
 
Index: orxonox/branches/updater/src/gui/orxonox_gui_update.cc
===================================================================
--- orxonox/branches/updater/src/gui/orxonox_gui_update.cc	(revision 3250)
+++ orxonox/branches/updater/src/gui/orxonox_gui_update.cc	(revision 3250)
@@ -0,0 +1,53 @@
+/* 
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software Foundation,
+   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  
+
+
+   ### File Specific:
+   main-programmer: Benjamin Grauer
+
+*/
+
+#include "orxonox_gui_update.h"
+#include <iostream>
+#include <string>
+
+#include "orxonox_gui.h"
+#include <stdio.h>
+using namespace std;
+
+/**
+   \brief Creates an Audio-Frame
+*/
+OrxonoxGuiUpdate::OrxonoxGuiUpdate ()
+{
+  updateFrame = new Frame ("Update-Options:");
+  updateBox = new Box ('v');
+  
+
+  updateFrame->fill (updateBox);
+}
+
+/**
+   \brief Return the Frame
+   \return Returns the Audio-frame
+*/
+Widget* OrxonoxGuiUpdate::getWidget ()
+{
+  return updateFrame;
+}
Index: orxonox/branches/updater/src/gui/orxonox_gui_update.h
===================================================================
--- orxonox/branches/updater/src/gui/orxonox_gui_update.h	(revision 3250)
+++ orxonox/branches/updater/src/gui/orxonox_gui_update.h	(revision 3250)
@@ -0,0 +1,31 @@
+/*!
+  \file orxonox_gui_update.h
+  \brief File that holds the class that creates the update-menu.
+*/
+
+#ifndef _ORXONOX_GUI_UPDATE_H
+#define _ORXONOX_GUI_UPDATE_H
+
+#include "orxonox_gui.h"
+#include <stdio.h>
+using namespace std;
+
+//! Class that creates the execute-Options.
+class OrxonoxGuiUpdate
+{
+ private:
+  Frame* updateFrame;          //!< The Frame that holds the updateOptions.
+  Box* updateBox;              //!< The Box that holds the updateOptions.
+  Button* update;              //!< The update Button
+
+ public:
+  OrxonoxGuiUpdate ();
+  ~OrxonoxGuiUpdate ();
+  
+  Widget* getWidget ();
+  
+
+};
+
+
+#endif /* _ORXONOX_GUI_UPDATE_H */